import pygame
import world
import player
import random
import dynObj
import pymunk
import reader
import physics
import pidController
import scrollingbackground
import spikelauncher

from controls import Controls
bankerSound = pygame.mixer.Sound("banker.wav")
bankerSound.set_volume(0.1)


youwin = pygame.image.load("youwin.png")
startscreen = pygame.image.load("title.jpg")
robotdruidSound = pygame.mixer.Sound("robotdruid.wav")
robotdruidSound.set_volume(0.1)


def nextLevel(currentLevel, levels,munkSpace):
    hasWon = 0
    if(currentLevel+1>=len(levels)):
        currentLevel=-1
        hasWon = 1
    level = levels[currentLevel+1]
    levelrect = level.get_rect();
        
    (w,p)= reader.readmap(level, levelrect.width, levelrect.height, physics.Physics(munkSpace))
    
    print ("LOADED LEVEL", currentLevel+1)
    print ("***** Level Size: ", levelrect.width, levelrect.height)
    
    return (w,p,hasWon)


playerNotDead = 1


hasWon = 0
started = 0

while playerNotDead:
    
    
    print "MY GOD ITS INITIALIZING***************************************************"
    true = 1
    false = 0
    pygame.mixer.init()
    pygame.mixer.music.load("regen_mklingen.mp3")
    pygame.mixer.music.play(-1)
    pygame.mixer.music.set_volume(0.2)
    pymunk.init_pymunk()
    
    munkSpace = pymunk.Space()
    munkSpace.gravity = (0, -900)
    
    
    
    
    levels = [ pygame.image.load("Start.png"),pygame.image.load("TheClimb.png"),pygame.image.load("Level2.png"), pygame.image.load("Spikeintro.png"), pygame.image.load("Roundandround2.png"), pygame.image.load("TestLevel.png"), pygame.image.load("StreightNoGood.png")]
    levelRect = levels[0].get_rect()
    # World containing the tile map.
    (w,p)= reader.readmap(levels[0], levelRect.width, levelRect.height, physics.Physics(munkSpace))
    #theWorld = world.World(100,100, physics.Physics(munkSpace))
    theWorld = w
    thePlayer = p
    
    cameraController = pidController.PIDController(0.7, 0.005, 0.02)
    
    # Exit when this is 1
    done = false
    
    #Screen and its size
    size = (640, 480)
    screen = pygame.display.set_mode(size)
    
    # Location of the camera in pixels.
    cameraPosition = [0,0]
    
    #Debug tile image.
    tileImage = pygame.image.load("tile.png")
    
    background = scrollingbackground.ScrollingBackground([pygame.image.load("jungle2.jpg")], [0.15])
    
    #Debug tile map.
    #theWorld.addTile(0, 0, 10, tileImage, 0)
    #theWorld.addTile(0, 1, 10, tileImage, 0)
    
    
    
    #thePlayer = player.Player(pygame.image.load("player.png"),
 
    #testObject = dynObj.DynObj(pygame.image.load("plant.png"),tileImage, false, theWorld.getTileCoordinates(3, 3, 32))
    
    #theWorld.addDynamicObject(pygame.image.load("plant.png"),pygame.image.load("deadplant.png"), false, theWorld.getTileCoordinates(10, 11, 32),  (32,32), (32,-150))
    
    #Simple color definition.
    black = 0,0,0
    
    #controls 
    controls = Controls()
    
    clock = pygame.time.Clock()
    
    currentLevel = 0
    
  
    while not done:
    #{
        #update controls (handles quit events as well)
        controls.update()
        #translate controls to component actions
        if controls.WDown or controls.UPDOWN:
            thePlayer.jump()
        elif controls.SDown or controls.DOWNDOWN:
            pass
        if controls.ADown or controls.LEFTDOWN:
            thePlayer.left()
        elif controls.DDown or controls.RIGHTDOWN:
            thePlayer.right()
        if (controls.MouseHit == 2) and controls.MouseDown:
            theWorld.kill(controls.MouseLoc[0] + cameraPosition[0], controls.MouseLoc[1] + cameraPosition[1])
        elif (controls.MouseHit == 1) and controls.MouseDown:
            theWorld.regenerate(controls.MouseLoc[0] + cameraPosition[0]+ 5, controls.MouseLoc[1] + cameraPosition[1])
        #Clear screen, draw world, and flip.
        screen.fill(black)

        if(not started):
            if(pygame.key.get_pressed()[pygame.constants.K_SPACE]):
                started = 1
            screen.set_clip(startscreen.get_rect())
            screen.blit(startscreen,startscreen.get_rect())
            pygame.display.flip()
            clock.tick(100)
            continue
        if(hasWon):
            if(pygame.key.get_pressed()[pygame.constants.K_SPACE]):
                hasWon = 0
            screen.set_clip(youwin.get_rect())
            screen.blit(youwin,youwin.get_rect())
            pygame.display.flip()
            clock.tick(100)
            continue

        background.draw(screen,cameraPosition,theWorld)
        thePlayer.update(theWorld)
        thePlayer.draw(screen,cameraPosition)
        theWorld.update()
        shouldDie  = theWorld.draw(screen, cameraPosition, thePlayer)
        
       
        
        if(controls.MouseDown):
            if(controls.MouseHit == 2):
                colorToDraw = (255-random.randint(0,150),10,10,random.randint(5,50))
            else:
                colorToDraw = (10,255-random.randint(0,150),10,random.randint(5,50))
            positionToDraw = (thePlayer.position[0]- cameraPosition[0], thePlayer.position[1]- cameraPosition[1] - 32)
            mouseLoc = (controls.MouseLoc[0]+ random.randint(-2,2), controls.MouseLoc[1]+random.randint(-2,2))
            pygame.draw.line(screen, colorToDraw, positionToDraw, mouseLoc, random.randint(5,10))
            pygame.draw.line(screen, (255,255,255,random.randint(5,10)), positionToDraw, mouseLoc, random.randint(1,3))
        
        cameraController.trackPlayer(cameraPosition, thePlayer.position)
        pygame.display.flip()
        

        if(shouldDie or theWorld.dies(thePlayer.position) or thePlayer.position[1]>1000):
            munkSpace = pymunk.Space()
            munkSpace.gravity = (0, -900)
            (w,p,win) = nextLevel(currentLevel-1, levels, munkSpace)
            hasWon = win
            theWorld = w
            thePlayer =p
            robotdruidSound.play()
            
        if(theWorld.wins(thePlayer.position)):
            munkSpace = pymunk.Space()
            munkSpace.gravity = (0, -900)
            lastlevel = currentLevel
            (w,p,win) = nextLevel(currentLevel, levels, munkSpace)
            hasWon = win
            theWorld = w
            thePlayer =p
            currentLevel+=1
            bankerSound.play()
        
    #}

   