import world
import pymunk
import pygame

spikeimg = pygame.image.load("spike.png")
class SpikeLauncher():
    def __init__(self, theWorld, r,c, img):
        self.image = img
        self.rect = img.get_rect()
        self.rect.topleft = (32*r, 32*c)
        self.spiketimer = 0
        self.tile = (r,c)
        self.spikes = []
    def update(self, theWorld, screen, cameraPosition, playerRect):
        self.spiketimer+=1
        
        if(self.spiketimer>20):
            self.shootSpikes(theWorld)
            self.spiketimer = 0
        
        removals = [] 
        for spike in self.spikes:
            spike.draw(screen, cameraPosition)
            collisionStatus = theWorld.collidesWithAnythingAtAll(spike.rect, playerRect)
            if(collisionStatus == 2):
                return 1
            elif(collisionStatus == 1 or collisionStatus >=3):
                removals.append(spike)
        
        for spike in removals:
            self.spikes.remove(spike)
            theWorld.physicsSystem.space.remove(spike.shape, spike.body)
        
        
        transformed = pygame.Rect(self.rect.topleft[0] - cameraPosition[0], self.rect.topleft[1] - cameraPosition[1], self.rect.width, self.rect.height)
    
        screen.blit(self.image, transformed)
        
        return 0
            
    def shootSpikes(self,theWorld):
        spikeRight = Spike(theWorld, self.tile[0]+1, self.tile[1],pygame.image.load("spike.png"), (500,0))
        spikeLeft = Spike(theWorld, self.tile[0]-1, self.tile[1],pygame.image.load("spike.png"), (-500, 0))
        spikeUp = Spike(theWorld, self.tile[0], self.tile[1]-1,pygame.image.load("spike.png"), (0, 500) )
        spikeDown = Spike(theWorld, self.tile[0], self.tile[1]+1,pygame.image.load("spike.png"),(0, -500))
        
        self.spikes.append(spikeRight)
        self.spikes.append(spikeLeft)
        self.spikes.append(spikeUp)
        self.spikes.append(spikeDown)
    
class Spike():
    def __init__(self, theWorld, r,c, img, velocity):
        self.image = img
        self.rect = img.get_rect()
        (bod, shp) = theWorld.physicsSystem.addSpike((32*r + 16, 32*c + 16))
        self.body = bod
        self.shape = shp
        self.body.velocity = velocity
        self.vel = velocity
        
        
    def draw(self, screen, cameraPosition):
        #Offset by camera position
        self.rect.center = (self.body.position[0], 480-self.body.position[1])   
        transformed = pygame.Rect(self.rect.topleft[0] - cameraPosition[0], self.rect.topleft[1] - cameraPosition[1], self.rect.width, self.rect.height)
    
        toDraw = self.image
        self.body.velocity = self.vel
        if(self.body.velocity[0] < 0):
            toDraw = pygame.transform.flip(toDraw, 1, 0)
           
        screen.blit(toDraw,transformed)
        
        
            
    